#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <cmath>

using namespace std;

struct point
{
	point()
	{
		val[0]=0;
		val[1]=0;
		val[2]=0;
	}

	point(int x, int y, int z): 
	{
		val[0] = x;
		val[1] = y;
		val[2] = z;
	}

	bool operator<(const &other) const
	{
		return lexicographical_compare(val, val+3, other.val, other.val+3);
	}

	bool operator==(const &other) const
	{
		return equal(val,val+3,other.val);
	}

	int val[3];
};

struct edge
{
	edge()
	{}
	edge(int _next, int _id):next(_next),id(_id)
	{}
	int next;
	int id;
};

struct node
{
	node() {}
	vector<int> desc;
	int eg;
};

int main()
{
	while(true)
	{
		int N, S, T, from, to;
		cin >> N >> S >> T;
		point from, to;
		cin>>from.val[0]>>from.val[1]>>from.val[2];
		cin>>to.val[0]>>to.val[1]>>to.val[2];
		if(!cin) break;
		map<point, int> points;
		vector<node> nodes;
		int vid=2;
		points[from]=0;
		points[to]=1;
		nodes.push_back(node());
		nodes.push_back(node());

		vector<edge> edges;
		
		for(int i=0; i<T; ++i)
		{
			point p1,p2;
			cin>>p1.val[0]>>p1.val[1]>>p1.val[2];
			cin>>p2.val[0]>>p2.val[1]>>p2.val[2];

			
			if(map.find(p1)!=map.end())
			{
				points[p1] = vid;
				nodes.push_back(node(from==to)());
				vid++;
			}

			if(map.find(p2)!=map.end())
			{
				points[p2] = vid;
				nodes.push_back(node());
				vid++;
			}

			int p1i = points[p1];
			int p2i = points[p2];

			edges.push_back(edge(p2i, i)); 

			nodes[p1i].desc.push_back(p2i);
			nodes[p2i].desc.push_back(p1i);
		}
		if(from==to)
		{
			 cout << "0.0000" << endl;
		}
		else
		{


		}
	}
}

